%define eecdb_user eecdb

Summary: Exam Environment Control Database
Name: exam-env-control-db
Version: 0.3.100.3
Release: 1
URL: https://git.inf2.tuwien.ac.at/inf2/priv/sw/%{name}
Source0: %{name}-%{version}.tar.xz
License: GPL
Group: Applications/System
BuildArchitectures: noarch
Requires: bash-base >= 0.6.8
Requires: bash-range-expand >= 0.13
Requires: websocketd
Requires: nginx
Requires(pre): /usr/sbin/useradd
Requires(pre): /usr/sbin/groupadd
Requires(pre): /usr/bin/getent
Requires(post): /usr/sbin/userdel
Requires(post): /usr/sbin/groupdel
%{?systemd_requires}

%description
Contains the Exam Environment Control DB.

Must run on same host where Status Collector DB is available, so
inotifywait works for both databases.

Provides a websocket to access the databse. Currently this access it read only.

%prep
%setup -q

%build

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}{%{_bindir},%{_libexecdir}/%{name}} \
      %{buildroot}%{_sysconfdir}/%{name}/nginx-confs \
      %{buildroot}%{_unitdir} \
      %{buildroot}%{_localstatedir}/{log,www/html/%{name}/static} \
      %{buildroot}%{_docdir}/%{name}-%{version}

cp -a libexec/. %{buildroot}%{_libexecdir}/%{name}/.
cp -a etc/. %{buildroot}%{_sysconfdir}/.
cp -a doc/. %{buildroot}%{_docdir}/%{name}-%{version}/.
cp -a %{name}-websocket.service %{buildroot}/%{_unitdir}/.

mkdir -p %{buildroot}/srv/db/%{name}

%pre
getent group %{eecdb_user} >/dev/null || \
    /usr/sbin/groupadd %{eecdb_user}
getent passwd %{eecdb_user} >/dev/null || {
    /usr/sbin/useradd --home-dir /home/%{eecdb_user} \
                      --comment "Exam Env Control DB" \
                      --gid %{eecdb_user} \
                      %{eecdb_user}
}

%post
[ -e %{_sysconfdir}/nginx/conf.d/%{name}.conf ] || {
    _domain=$(hostname -d)
    _nginx_conf="%{_sysconfdir}/%{name}/nginx-confs/%{name}-websocket-$_domain.conf"
    if [ -f "$_nginx_conf" ]
    then
        ln -snf "$_nginx_conf" "%{_sysconfdir}/nginx/conf.d/%{name}.conf"
        if systemctl is-active --quiet nginx; then
          systemctl reload nginx
        fi
    else
        echo "exam-env-contro-db %post: no such file: $_nginx_conf" \
             >&2
        exit 1
    fi
}

%postun
%systemd_postun_with_restart %{name}-websocket.service
if (( $1 == 0 ))
then
    /usr/sbin/userdel --remove %{eecdb_user} > /dev/null 2>&1 || true
    /usr/sbin/groupdel --remove  %{eecdb_user} > /dev/null 2>&1 || true
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_unitdir}/%{name}-websocket.service
%{_libexecdir}/*
%config(noreplace) %{_sysconfdir}/default/%{name}
%{_sysconfdir}/%{name}/*
%ghost %{_sysconfdir}/nginx/conf.d/%{name}-websocket.conf
/srv/db/%{name}
%doc %{_docdir}/%{name}-%{version}
